Index: uspace/lib/posix/fnmatch.c
===================================================================
--- uspace/lib/posix/fnmatch.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/fnmatch.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -33,5 +33,12 @@
  */
 
-// TODO: clean this up a bit
+/* This file contains an implementation of the fnmatch() pattern matching
+ * function. There is more code than necessary to account for the possibility
+ * of adding POSIX-like locale support to the system in the future. Functions
+ * that are only necessary for locale support currently simply use single
+ * characters for "collation elements". 
+ * When (or if) locales are properly implemented, extending this implementation
+ * will be fairly straightforward.
+ */
 
 #include "stdbool.h"
@@ -46,6 +53,5 @@
 #include "fnmatch.h"
 
-// TODO: documentation
-
+/* Returned by _match... functions. */
 #define INVALID_PATTERN -1
 
@@ -53,6 +59,9 @@
  * but may be extended for better locale support.
  */
-typedef int _coll_elm_t;
-
+typedef int coll_elm_t;
+
+/** Return value indicating that the element in question
+ * is not valid in the current locale. (That is, if locales are supported.)
+ */
 #define COLL_ELM_INVALID -1
 
@@ -60,7 +69,7 @@
  *
  * @param str
- * @return
- */
-static _coll_elm_t _coll_elm_get(const char* str)
+ * @return Matching collating element or COLL_ELM_INVALID.
+ */
+static coll_elm_t _coll_elm_get(const char* str)
 {
 	if (str[0] == '\0' || str[1] != '\0') {
@@ -75,5 +84,5 @@
  * @return
  */
-static _coll_elm_t _coll_elm_char(int c)
+static coll_elm_t _coll_elm_char(int c)
 {
 	return c;
@@ -86,10 +95,18 @@
  * @return 0 if the element doesn't match, or the number of characters matched.
  */
-static int _coll_elm_match(_coll_elm_t elm, const char *str)
+static int _coll_elm_match(coll_elm_t elm, const char *str)
 {
 	return elm == *str;
 }
 
-static int _coll_elm_between(_coll_elm_t first, _coll_elm_t second,
+/** Checks whether a string begins with a collating element in the given range.
+ *  Ordering depends on the locale (if locales are supported).
+ *
+ * @param first First element of the range.
+ * @param second Last element of the range.
+ * @param str String to match.
+ * @return 0 if there is no match, or the number of characters matched.
+ */
+static int _coll_elm_between(coll_elm_t first, coll_elm_t second,
     const char *str)
 {
@@ -105,5 +122,6 @@
  * @param buf_sz Read buffer's size. If the buffer is not large enough for
  *    the entire string, the string is cut with no error indication.
- * @return
+ * @param flags Flags modifying the behavior.
+ * @return True on success, false if the pattern is invalid.
  */
 static bool _get_delimited(
@@ -171,5 +189,5 @@
 };
 
-/**
+/** Compare function for binary search in the _char_classes array. 
  * 
  * @param key
@@ -183,9 +201,9 @@
 }
 
-/**
+/** Returns whether the given character belongs to the specified character class.
  * 
- * @param cname
- * @param c
- * @return
+ * @param cname Name of the character class.
+ * @param c Character.
+ * @return True if the character belongs to the class, false otherwise.
  */
 static bool _is_in_class (const char *cname, int c)
@@ -205,10 +223,15 @@
 }
 
-/**
+/** Tries to parse an initial part of the pattern as a character class pattern,
+ *  and if successful, matches the beginning of the given string against the class.
  * 
- * @param pattern
- * @param str
- * @param flags
- * @return
+ * @param pattern Pointer to the pattern to match. Must begin with a class
+ *    specifier and is repositioned to the first character after the specifier
+ *    if successful.
+ * @param str String to match.
+ * @param flags Flags modifying the behavior (see fnmatch()).
+ * @return INVALID_PATTERN if the pattern doesn't start with a valid class
+ *    specifier, 0 if the beginning of the matched string doesn't belong
+ *    to the class, or positive number of characters matched.
  */
 static int _match_char_class(const char **pattern, const char *str, int flags)
@@ -225,12 +248,18 @@
 /************** END CHARACTER CLASSES ****************/
 
-/**
+/** Reads the next collating element in the pattern, taking into account
+ *  locale (if supported) and flags (see fnmatch()).
  * 
- * @param pattern
- * @param flags
- * @return
- */
-static _coll_elm_t _next_coll_elm(const char **pattern, int flags)
-{
+ * @param pattern Pattern.
+ * @param flags Flags given to fnmatch().
+ * @return Collating element on success,
+ *     or COLL_ELM_INVALID if the pattern is invalid.
+ */
+static coll_elm_t _next_coll_elm(const char **pattern, int flags)
+{
+	assert(pattern != NULL);
+	assert(*pattern != NULL);
+	assert(**pattern != '\0');
+
 	const char *p = *pattern;
 	const bool noescape = (flags & FNM_NOESCAPE) != 0;
@@ -257,19 +286,27 @@
 	if (!noescape && *p == '\\') {
 		p++;
+		if (*p == '\0') {
+			*pattern = p;
+			return COLL_ELM_INVALID;
+		}
 	}
 	if (pathname && *p == '/') {
 		return COLL_ELM_INVALID;
 	}
-
+	
 	*pattern = p + 1;
 	return _coll_elm_char(*p);
 }
 
-/**
+/** Matches the beginning of the given string against a bracket expression
+ *  the pattern begins with.
  * 
- * @param pattern
- * @param str
- * @param flags
- * @return
+ * @param pattern Pointer to the beginning of a bracket expression in a pattern.
+ *     On success, the pointer is moved to the first character after the
+ *     bracket expression.
+ * @param str Unmatched part of the string.
+ * @param flags Flags given to fnmatch().
+ * @return INVALID_PATTERN if the pattern is invalid, 0 if there is no match
+ *     or the number of matched characters on success.
  */
 static int _match_bracket_expr(const char **pattern, const char *str, int flags)
@@ -315,5 +352,5 @@
 	}
 	
-	_coll_elm_t current_elm = COLL_ELM_INVALID;
+	coll_elm_t current_elm = COLL_ELM_INVALID;
 	
 	while (*p != ']') {
@@ -322,5 +359,5 @@
 			/* Range expression. */
 			p++;
-			_coll_elm_t end_elm = _next_coll_elm(&p, flags);
+			coll_elm_t end_elm = _next_coll_elm(&p, flags);
 			if (end_elm == COLL_ELM_INVALID) {
 				return INVALID_PATTERN;
@@ -357,10 +394,14 @@
 }
 
-/**
+/** Matches a portion of the pattern containing no asterisks (*) against
+ *  the given string.
  * 
- * @param pattern
- * @param string
- * @param flags
- * @return
+ * @param pattern Pointer to the unmatched portion of the pattern.
+ *     On success, the pointer is moved to the first asterisk, or to the
+ *     terminating nul character, whichever occurs first.
+ * @param string Pointer to the input string. On success, the pointer is moved
+ *     to the first character that wasn't explicitly matched.
+ * @param flags Flags given to fnmatch().
+ * @return True if the entire subpattern matched. False otherwise.
  */
 static bool _partial_match(const char **pattern, const char **string, int flags)
@@ -456,10 +497,10 @@
 }
 
-/**
+/** Match string against a pattern.
  * 
- * @param pattern
- * @param string
- * @param flags
- * @return
+ * @param pattern Pattern.
+ * @param string String to match.
+ * @param flags Flags given to fnmatch().
+ * @return True if the string matched the pattern, false otherwise.
  */
 static bool _full_match(const char *pattern, const char *string, int flags)
@@ -496,5 +537,5 @@
 			end = string;
 		} else {
-			end= strchrnul(string, pathname ? '/' : '\0');
+			end = strchrnul(string, pathname ? '/' : '\0');
 		}
 
@@ -518,8 +559,9 @@
 }
 
-/**
+/** Transform the entire string to lowercase.
  * 
- * @param s
- * @return
+ * @param s Input string.
+ * @return Newly allocated copy of the input string with all uppercase
+ *     characters folded to their lowercase variants.
  */
 static char *_casefold(const char *s)
Index: uspace/lib/posix/locale.c
===================================================================
--- uspace/lib/posix/locale.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/locale.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -42,5 +42,9 @@
 #include "string.h"
 
-// TODO: documentation
+/* Just a very basic dummy implementation.
+ * This should allow code using locales to work properly, but doesn't provide
+ * any localization functionality.
+ * Should be extended/rewritten when or if HelenOS supports locales natively.
+ */
 
 struct __posix_locale {
@@ -75,9 +79,9 @@
 };
 
-/**
+/** Set program locale.
  * 
- * @param category
- * @param locale
- * @return
+ * @param category What category to set.
+ * @param locale Locale name.
+ * @return Original locale name on success, NULL on failure.
  */
 char *posix_setlocale(int category, const char *locale)
@@ -91,7 +95,7 @@
 }
 
-/**
+/** Return locale-specific information.
  * 
- * @return
+ * @return Information about the current locale.
  */
 struct posix_lconv *posix_localeconv(void)
@@ -101,8 +105,8 @@
 }
 
-/**
+/** Duplicate locale object.
  * 
- * @param locobj
- * @return
+ * @param locobj Object to duplicate.
+ * @return Duplicated object.
  */
 posix_locale_t posix_duplocale(posix_locale_t locobj)
@@ -121,7 +125,7 @@
 }
 
-/**
+/** Free locale object.
  * 
- * @param locobj
+ * @param locobj Object to free.
  */
 void posix_freelocale(posix_locale_t locobj)
@@ -132,10 +136,10 @@
 }
 
-/**
+/** Create or modify a locale object.
  * 
- * @param category_mask
- * @param locale
- * @param base
- * @return
+ * @param category_mask Mask of categories to be set or modified.
+ * @param locale Locale to be used.
+ * @param base Object to modify. 0 if new object is to be created.
+ * @return The new/modified locale object.
  */
 posix_locale_t posix_newlocale(int category_mask, const char *locale,
@@ -159,13 +163,13 @@
 }
 
-/**
+/** Set locale for the current thread.
  * 
- * @param newloc
- * @return
+ * @param newloc Locale to use.
+ * @return The previously set locale or LC_GLOBAL_LOCALE
  */
 posix_locale_t posix_uselocale(posix_locale_t newloc)
 {
 	// TODO
-	return NULL;
+	return LC_GLOBAL_LOCALE;
 }
 
Index: uspace/lib/posix/locale.h
===================================================================
--- uspace/lib/posix/locale.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/locale.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -35,6 +35,4 @@
 #ifndef POSIX_LOCALE_H_
 #define POSIX_LOCALE_H_
-
-// TODO: documentation
 
 #ifndef NULL
Index: uspace/lib/posix/signal.c
===================================================================
--- uspace/lib/posix/signal.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/signal.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -45,9 +45,18 @@
 #include "libc/task.h"
 
-// TODO: documentation
+/* This file implements a fairly dumb and incomplete "simulation" of
+ * POSIX signals. Since HelenOS doesn't support signals and mostly doesn't
+ * have any equivalent functionality, most of the signals are useless. The
+ * main purpose of this implementation is thus to help port applications using
+ * signals with minimal modification, but if the application uses signals for
+ * anything non-trivial, it's quite probable it won't work properly even if
+ * it builds without problems.
+ */
 
 /* Used to serialize signal handling. */
 static FIBRIL_MUTEX_INITIALIZE(_signal_mutex);
 
+static LIST_INITIALIZE(_signal_queue);
+
 static posix_sigset_t _signal_mask = 0;
 
@@ -55,4 +64,5 @@
     .sa_mask = 0, .sa_flags = 0, .sa_sigaction = NULL }
 
+/* Actions associated with each signal number. */
 static struct posix_sigaction _signal_actions[_TOP_SIGNAL + 1] = {
 	DEFAULT_HANDLER, DEFAULT_HANDLER, DEFAULT_HANDLER, DEFAULT_HANDLER, 
@@ -126,5 +136,5 @@
 }
 
-/**
+/** Just an empty function to get an unique pointer value for comparison.
  *
  * @param signo
@@ -135,5 +145,5 @@
 }
 
-/**
+/** Empty function to be used as ignoring handler.
  * 
  * @param signo
@@ -144,8 +154,8 @@
 }
 
-/**
- * 
- * @param set
- * @return
+/** Clear the signal set.
+ * 
+ * @param set Pointer to the signal set.
+ * @return Always returns zero.
  */
 int posix_sigemptyset(posix_sigset_t *set)
@@ -157,8 +167,8 @@
 }
 
-/**
- * 
- * @param set
- * @return
+/** Fill the signal set (i.e. add all signals).
+ * 
+ * @param set Pointer to the signal set.
+ * @return Always returns zero.
  */
 int posix_sigfillset(posix_sigset_t *set)
@@ -170,9 +180,9 @@
 }
 
-/**
- * 
- * @param set
- * @param signo
- * @return
+/** Add a signal to the set.
+ * 
+ * @param set Pointer to the signal set.
+ * @param signo Signal number to add.
+ * @return Always returns zero.
  */
 int posix_sigaddset(posix_sigset_t *set, int signo)
@@ -184,9 +194,9 @@
 }
 
-/**
- * 
- * @param set
- * @param signo
- * @return
+/** Delete a signal from the set.
+ * 
+ * @param set Pointer to the signal set.
+ * @param signo Signal number to remove.
+ * @return Always returns zero.
  */
 int posix_sigdelset(posix_sigset_t *set, int signo)
@@ -198,9 +208,9 @@
 }
 
-/**
- * 
- * @param set
- * @param signo
- * @return
+/** Inclusion test for a signal set.
+ * 
+ * @param set Pointer to the signal set.
+ * @param signo Signal number to query.
+ * @return 1 if the signal is in the set, 0 otherwise.
  */
 int posix_sigismember(const posix_sigset_t *set, int signo)
@@ -211,5 +221,7 @@
 }
 
-/**
+/** Unsafe variant of the sigaction() function.
+ *  Doesn't do any checking of its arguments and
+ *  does not deal with thread-safety.
  * 
  * @param sig
@@ -231,10 +243,12 @@
 }
 
-/**
- * 
- * @param sig
- * @param act
- * @param oact
- * @return
+/** Sets a new action for the given signal number.
+ * 
+ * @param sig Signal number to set action for.
+ * @param act If not NULL, contents of this structure are
+ *     used as the new action for the signal.
+ * @param oact If not NULL, the original action associated with the signal
+ *     is stored in the structure pointer to. 
+ * @return -1 with errno set on failure, 0 on success.
  */
 int posix_sigaction(int sig, const struct posix_sigaction *restrict act,
@@ -252,5 +266,5 @@
 		    " or fully unsupported signal. This handler may only be"
 		    " invoked by the raise() function, which may not be what"
-		    " the application developer intended.\nSignal name");
+		    " the application developer intended");
 	}
 
@@ -262,9 +276,9 @@
 }
 
-/**
- * 
- * @param sig
- * @param func
- * @return
+/** Sets a new handler for the given signal number.
+ * 
+ * @param sig Signal number to set handler for.
+ * @param func Handler function.
+ * @return SIG_ERR on failure, original handler on success.
  */
 void (*posix_signal(int sig, void (*func)(int)))(int)
@@ -284,14 +298,39 @@
 }
 
-/**
- * 
- * @param signo
- * @param siginfo
- * @return
- */
-static int _raise_sigaction(int signo, posix_siginfo_t *siginfo)
+typedef struct {
+	link_t link;
+	int signo;
+	posix_siginfo_t siginfo;
+} signal_queue_item;
+
+/** Queue blocked signal.
+ *
+ * @param signo Signal number.
+ * @param siginfo Additional information about the signal.
+ */
+static void _queue_signal(int signo, posix_siginfo_t *siginfo)
 {
 	assert(signo >= 0 && signo <= _TOP_SIGNAL);
 	assert(siginfo != NULL);
+	
+	signal_queue_item *item = malloc(sizeof(signal_queue_item));
+	link_initialize(&(item->link));
+	item->signo = signo;
+	memcpy(&item->siginfo, siginfo, sizeof(posix_siginfo_t));
+	list_append(&(item->link), &_signal_queue);
+}
+
+
+/** Executes an action associated with the given signal.
+ *
+ * @param signo Signal number.
+ * @param siginfo Additional information about the circumstances of this raise.
+ * @return 0 if the action has been successfully executed. -1 if the signal is
+ *     blocked.
+ */
+static int _raise_sigaction(int signo, posix_siginfo_t *siginfo)
+{
+	assert(signo >= 0 && signo <= _TOP_SIGNAL);
+	assert(siginfo != NULL);
 
 	fibril_mutex_lock(&_signal_mutex);
@@ -301,5 +340,5 @@
 	if (posix_sigismember(&_signal_mask, signo) ||
 	    action.sa_handler == SIG_HOLD) {
-		// TODO: queue signal
+		_queue_signal(signo, siginfo);
 		fibril_mutex_unlock(&_signal_mutex);
 		return -1;
@@ -312,5 +351,5 @@
 	if ((action.sa_flags & SA_RESETHAND) && signo != SIGILL && signo != SIGTRAP) {
 		_signal_actions[signo] = (struct posix_sigaction) DEFAULT_HANDLER;
-	};
+	}
 
 	if (action.sa_flags & SA_SIGINFO) {
@@ -327,8 +366,32 @@
 }
 
-/**
- * 
- * @param sig
- * @return
+/** Raise all unblocked previously queued signals.
+ */
+static void _dequeue_unblocked_signals()
+{
+	link_t *iterator = _signal_queue.head.next;
+	link_t *next;
+	
+	while (iterator != &(_signal_queue).head) {
+		next = iterator->next;
+		
+		signal_queue_item *item =
+		    list_get_instance(iterator, signal_queue_item, link);
+		
+		if (!posix_sigismember(&_signal_mask, item->signo) &&
+		    _signal_actions[item->signo].sa_handler != SIG_HOLD) {
+			list_remove(&(item->link));
+			_raise_sigaction(item->signo, &(item->siginfo));
+			free(item);
+		}
+		
+		iterator = next;
+	}
+}
+
+/** Raise a signal for the calling process.
+ * 
+ * @param sig Signal number.
+ * @return -1 with errno set on failure, 0 on success.
  */
 int posix_raise(int sig)
@@ -346,9 +409,10 @@
 }
 
-/**
- * 
- * @param pid
- * @param signo
- * @return
+/** Raises a signal for a selected process.
+ * 
+ * @param pid PID of the process for which the signal shall be raised.
+ * @param signo Signal to raise.
+ * @return -1 with errno set on failure (possible errors include unsupported
+ *     action, invalid signal number, lack of permissions, etc.), 0 on success.
  */
 int posix_kill(posix_pid_t pid, int signo)
@@ -360,11 +424,11 @@
 	}
 
+	if (signo > _TOP_SIGNAL) {
+		errno = EINVAL;
+		return -1;
+	}
+
 	if (pid == (posix_pid_t) task_get_id()) {
 		return posix_raise(signo);
-	}
-
-	if (pid > _TOP_SIGNAL) {
-		errno = EINVAL;
-		return -1;
 	}
 
@@ -382,9 +446,10 @@
 }
 
-/**
- * 
- * @param pid
- * @param sig
- * @return
+/** Send a signal to a process group. Always fails at the moment because of
+ *  lack of this functionality in HelenOS.
+ * 
+ * @param pid PID of the process group.
+ * @param sig Signal number.
+ * @return -1 on failure, 0 on success (see kill()).
  */
 int posix_killpg(posix_pid_t pid, int sig)
@@ -394,8 +459,8 @@
 }
 
-/**
- * 
- * @param pinfo
- * @param message
+/** Outputs information about the signal to the standard error stream.
+ * 
+ * @param pinfo SigInfo struct to write.
+ * @param message String to output alongside human-readable signal description.
  */
 void posix_psiginfo(const posix_siginfo_t *pinfo, const char *message)
@@ -406,8 +471,8 @@
 }
 
-/**
- * 
- * @param signum
- * @param message
+/** Outputs information about the signal to the standard error stream.
+ * 
+ * @param signum Signal number.
+ * @param message String to output alongside human-readable signal description.
  */
 void posix_psignal(int signum, const char *message)
@@ -421,10 +486,10 @@
 }
 
-/**
- * 
- * @param how
- * @param set
- * @param oset
- * @return
+/** Manipulate the signal mask of the calling thread.
+ * 
+ * @param how What to do with the mask.
+ * @param set Signal set to work with.
+ * @param oset If not NULL, the original signal mask is coppied here.
+ * @return 0 success, errorcode on failure.
  */
 int posix_thread_sigmask(int how, const posix_sigset_t *restrict set,
@@ -452,6 +517,6 @@
 		}
 	}
-
-	// TODO: queued signal handling
+	
+	_dequeue_unblocked_signals();
 
 	fibril_mutex_unlock(&_signal_mutex);
@@ -460,10 +525,10 @@
 }
 
-/**
- * 
- * @param how
- * @param set
- * @param oset
- * @return
+/** Manipulate the signal mask of the process.
+ * 
+ * @param how What to do with the mask.
+ * @param set Signal set to work with.
+ * @param oset If not NULL, the original signal mask is coppied here.
+ * @return 0 on success, -1 with errno set on failure.
  */
 int posix_sigprocmask(int how, const posix_sigset_t *restrict set,
Index: uspace/lib/posix/signal.h
===================================================================
--- uspace/lib/posix/signal.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/signal.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -36,6 +36,4 @@
 #define POSIX_SIGNAL_H_
 
-// TODO: documentation
-
 #include "libc/errno.h"
 #include "sys/types.h"
@@ -57,5 +55,5 @@
 typedef uint32_t posix_sigset_t;
 typedef struct posix_mcontext {
-	// FIXME: should not be empty to avoid compiler warnings (-pedantic)
+	/* must not be empty to avoid compiler warnings (-pedantic) */
 	int dummy;
 } posix_mcontext_t;
Index: uspace/lib/posix/stdio.c
===================================================================
--- uspace/lib/posix/stdio.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/stdio.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -44,6 +44,8 @@
 #include "assert.h"
 #include "errno.h"
+#include "stdlib.h"
 #include "string.h"
 #include "sys/types.h"
+#include "unistd.h"
 
 #include "libc/io/printf_core.h"
@@ -255,5 +257,5 @@
 	assert(stream != NULL);
 	
-	/* Retieve the node. */
+	/* Retrieve the node. */
 	struct stat st;
 	int rc;
@@ -263,4 +265,13 @@
 	} else {
 		rc = stat(filename, &st);
+		if (-rc == ENOENT) {
+			/* file does not exist, create new file */
+			FILE* tmp = fopen(filename, mode);
+			if (tmp != NULL) {
+				fclose(tmp);
+				/* try again */
+				rc = stat(filename, &st);
+			}
+		}
 	}
 	
@@ -273,5 +284,5 @@
 	fdi_node_t node = {
 		.fs_handle = st.fs_handle,
-		.devmap_handle = st.devmap_handle,
+		.service_id = st.service_id,
 		.index = st.index
 	};
@@ -306,30 +317,4 @@
 	
 	return stream;
-}
-
-/**
- *
- * @param buf
- * @param size
- * @param mode
- * @return
- */
-FILE *posix_fmemopen(void *restrict buf, size_t size,
-    const char *restrict mode)
-{
-	// TODO
-	not_implemented();
-}
-
-/**
- *
- * @param bufp
- * @param sizep
- * @return
- */
-FILE *posix_open_memstream(char **bufp, size_t *sizep)
-{
-	// TODO
-	not_implemented();
 }
 
@@ -724,6 +709,6 @@
  * Rename a file or directory.
  *
- * @param old
- * @param new
+ * @param old Old pathname.
+ * @param new New pathname.
  * @return Zero on success, -1 (with errno set) otherwise.
  */
@@ -734,12 +719,111 @@
 
 /**
- * 
- * @param s
- * @return
+ * Get a unique temporary file name (obsolete).
+ *
+ * @param s Buffer for the file name. Must be at least L_tmpnam bytes long.
+ * @return The value of s on success, NULL on failure.
  */
 char *posix_tmpnam(char *s)
 {
-	// TODO: low priority, just a compile-time dependency of binutils
-	not_implemented();
+	assert(L_tmpnam >= posix_strlen("/tmp/tnXXXXXX"));
+	
+	static char buffer[L_tmpnam + 1];
+	if (s == NULL) {
+		s = buffer;
+	}
+	
+	posix_strcpy(s, "/tmp/tnXXXXXX");
+	posix_mktemp(s);
+	
+	if (*s == '\0') {
+		/* Errno set by mktemp(). */
+		return NULL;
+	}
+	
+	return s;
+}
+
+/**
+ * Get an unique temporary file name with additional constraints (obsolete).
+ *
+ * @param dir Path to directory, where the file should be created.
+ * @param pfx Optional prefix up to 5 characters long.
+ * @return Newly allocated unique path for temporary file. NULL on failure.
+ */
+char *posix_tempnam(const char *dir, const char *pfx)
+{
+	/* Sequence number of the filename. */
+	static int seq = 0;
+	
+	size_t dir_len = posix_strlen(dir);
+	if (dir[dir_len - 1] == '/') {
+		dir_len--;
+	}
+	
+	size_t pfx_len = posix_strlen(pfx);
+	if (pfx_len > 5) {
+		pfx_len = 5;
+	}
+	
+	char *result = malloc(dir_len + /* slash*/ 1 +
+	    pfx_len + /* three-digit seq */ 3 + /* .tmp */ 4 + /* nul */ 1);
+	
+	if (result == NULL) {
+		errno = ENOMEM;
+		return NULL;
+	}
+	
+	char *res_ptr = result;
+	posix_strncpy(res_ptr, dir, dir_len);
+	res_ptr += dir_len;
+	posix_strncpy(res_ptr, pfx, pfx_len);
+	res_ptr += pfx_len;
+	
+	for (; seq < 1000; ++seq) {
+		snprintf(res_ptr, 8, "%03d.tmp", seq);
+		
+		int orig_errno = errno;
+		errno = 0;
+		/* Check if the file exists. */
+		if (posix_access(result, F_OK) == -1) {
+			if (errno == ENOENT) {
+				errno = orig_errno;
+				break;
+			} else {
+				/* errno set by access() */
+				return NULL;
+			}
+		}
+	}
+	
+	if (seq == 1000) {
+		free(result);
+		errno = EINVAL;
+		return NULL;
+	}
+	
+	return result;
+}
+
+/**
+ * Create and open an unique temporary file.
+ * The file is automatically removed when the stream is closed.
+ *
+ * @param dir Path to directory, where the file should be created.
+ * @param pfx Optional prefix up to 5 characters long.
+ * @return Newly allocated unique path for temporary file. NULL on failure.
+ */
+FILE *posix_tmpfile(void)
+{
+	char filename[] = "/tmp/tfXXXXXX";
+	int fd = posix_mkstemp(filename);
+	if (fd == -1) {
+		/* errno set by mkstemp(). */
+		return NULL;
+	}
+	
+	/* Unlink the created file, so that it's removed on close(). */
+	posix_unlink(filename);
+	return fdopen(fd, "w+");
 }
 
Index: uspace/lib/posix/stdio.h
===================================================================
--- uspace/lib/posix/stdio.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/stdio.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -65,7 +65,4 @@
 extern FILE *posix_freopen(const char *restrict filename,
     const char *restrict mode, FILE *restrict stream);
-extern FILE *posix_fmemopen(void *restrict buf, size_t size,
-    const char *restrict mode);
-extern FILE *posix_open_memstream(char **bufp, size_t *sizep);
 
 /* Error Messages */
@@ -123,6 +120,14 @@
 #define L_tmpnam PATH_MAX
 extern char *posix_tmpnam(char *s);
+extern char *posix_tempnam(const char *dir, const char *pfx);
+extern FILE *posix_tmpfile(void);
 
 #ifndef LIBPOSIX_INTERNAL
+	/* DEBUG macro does not belong to POSIX stdio.h. Its unconditional
+	 * definition in the native stdio.h causes unexpected behaviour of
+	 * applications which uses their own DEBUG macro (e.g. debugging
+	 * output is printed even if not desirable). */
+	#undef DEBUG
+
 	#define ctermid posix_ctermid
 
@@ -176,4 +181,6 @@
 
 	#define tmpnam posix_tmpnam
+	#define tempnam posix_tempnam
+	#define tmpfile posix_tmpfile
 #endif
 
Index: uspace/lib/posix/stdlib.c
===================================================================
--- uspace/lib/posix/stdlib.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/stdlib.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -40,9 +40,14 @@
 
 #include "errno.h"
+#include "fcntl.h"
 #include "limits.h"
+#include "string.h"
+#include "sys/stat.h"
+#include "unistd.h"
 
 #include "libc/sort.h"
 #include "libc/str.h"
 #include "libc/vfs/vfs.h"
+#include "libc/stats.h"
 
 /**
@@ -385,18 +390,87 @@
 
 /**
- * 
- * @param tmpl
- * @return
+ * Creates and opens an unique temporary file from template.
+ *
+ * @param tmpl Template. Last six characters must be XXXXXX.
+ * @return The opened file descriptor or -1 on error.
+ */
+int posix_mkstemp(char *tmpl)
+{
+	int fd = -1;
+	
+	char *tptr = tmpl + posix_strlen(tmpl) - 6;
+	
+	while (fd < 0) {
+		if (*posix_mktemp(tmpl) == '\0') {
+			/* Errno set by mktemp(). */
+			return -1;
+		}
+		
+		fd = open(tmpl, O_RDWR | O_CREAT | O_EXCL, S_IRUSR | S_IWUSR);
+		
+		if (fd == -1) {
+			/* Restore template to it's original state. */
+			snprintf(tptr, 7, "XXXXXX");
+		}
+	}
+	
+	return fd;
+}
+
+/**
+ * Creates an unique temporary file name from template.
+ *
+ * @param tmpl Template. Last six characters must be XXXXXX.
+ * @return The value of tmpl. The template is modified in place.
+ *    If no temporary file name can be created, template is
+ *    reduced to an empty string.
  */
 char *posix_mktemp(char *tmpl)
 {
-	// TODO: low priority, just a compile-time dependency of binutils
-	not_implemented();
+	int tmpl_len = posix_strlen(tmpl);
+	if (tmpl_len < 6) {
+		errno = EINVAL;
+		*tmpl = '\0';
+		return tmpl;
+	}
+	
+	char *tptr = tmpl + tmpl_len - 6;
+	if (posix_strcmp(tptr, "XXXXXX") != 0) {
+		errno = EINVAL;
+		*tmpl = '\0';
+		return tmpl;
+	}
+	
+	static int seq = 0;
+	
+	for (; seq < 1000000; ++seq) {
+		snprintf(tptr, 7, "%06d", seq);
+		
+		int orig_errno = errno;
+		errno = 0;
+		/* Check if the file exists. */
+		if (posix_access(tmpl, F_OK) == -1) {
+			if (errno == ENOENT) {
+				errno = orig_errno;
+				break;
+			} else {
+				/* errno set by access() */
+				*tmpl = '\0';
+				return tmpl;
+			}
+		}
+	}
+	
+	if (seq == 10000000) {
+		errno = EEXIST;
+		*tmpl = '\0';
+		return tmpl;
+	}
+	
+	return tmpl;
 }
 
 /**
  * Get system load average statistics.
- *
- * Not supported. Always returns -1.
  *
  * @param loadavg Array where the load averages shall be placed.
@@ -406,5 +480,23 @@
 int bsd_getloadavg(double loadavg[], int nelem)
 {
-	return -1;
+	assert(nelem > 0);
+	
+	size_t count;
+	load_t *loads = stats_get_load(&count);
+	
+	if (loads == NULL) {
+		return -1;
+	}
+	
+	if (((size_t) nelem) < count) {
+		count = nelem;
+	}
+	
+	for (size_t i = 0; i < count; ++i) {
+		loadavg[i] = (double) loads[i];
+	}
+	
+	free(loads);
+	return count;
 }
 
Index: uspace/lib/posix/stdlib.h
===================================================================
--- uspace/lib/posix/stdlib.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/stdlib.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -113,4 +113,7 @@
 extern void posix_free(void *ptr);
 
+/* Temporary Files */
+extern int posix_mkstemp(char *tmpl);
+
 /* Legacy Declarations */
 extern char *posix_mktemp(char *tmpl);
@@ -158,4 +161,6 @@
 	#define free posix_free
 
+	#define mkstemp posix_mkstemp
+
 	#define mktemp posix_mktemp
 	#define getloadavg bsd_getloadavg
Index: uspace/lib/posix/stdlib/strtold.c
===================================================================
--- uspace/lib/posix/stdlib/strtold.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/posix/stdlib/strtold.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -48,5 +48,5 @@
 #include "../limits.h"
 
-// FIXME: #include <float.h>
+#include "../float.h"
 
 #ifndef HUGE_VALL
